#if !defined(__STRINGIFY2)
#define __STRINGIFY2(__p) #__p
#define __STRINGIFY(__p) __STRINGIFY2(__p)
#endif
#define CAT(X, Y) X ## Y
#define CAT2(X, Y) CAT(X,Y)

#ifdef AVR
#define __section ".progmem"
#else
#define __section ".rodata"
#endif

#define INCBIN(__variable, __fileName)           \
__asm__ (                                                                        \
    ".pushsection " __section                                          "\n\t"    \
    ".global " __STRINGIFY(__variable)                                 "\n\t"    \
    ".type " __STRINGIFY(__variable) ", @object"                       "\n\t"    \
    ".type " __STRINGIFY(CAT(__variable,_end)) ", @object"                       "\n\t"    \
    __STRINGIFY(__variable) ":"                                        "\n\t" \
    ".incbin \"" __fileName "\""                                       "\n\t"    \
    ".global " __STRINGIFY(CAT(__variable,_end))                          "\n\t" \
    __STRINGIFY(CAT(__variable,_end))  ":"                         "\n\t" \
    ".size " __STRINGIFY(__variable) ", .-" __STRINGIFY(__variable)    "\n\t"    \
    ".align 1"                                                         "\n\t"    \
    ".popsection"                                                                \
);                                                                               \
extern uint8_t __variable[] __attribute__((section(__section)));	\
 extern uint8_t CAT(__variable, _end)[] __attribute__((section(__section)));	\
				       //const size_t CAT(__variable, _size) = CAT(__variable, _end) - __variable;
